<script setup lang="ts">
import { ref } from 'vue'

import { useUserStore } from '@/stores/user'
import { useCheckInOutStore } from '@/stores/CheckInOut'

import type { CheckDate, CheckUser } from '@/types/CheckInOut/CheckInOutDate'
import type { User } from '@/types/User'

import CheckmarkDialogVue from '@/components/CheckmarkDialog.vue'

const checkInOutStore = useCheckInOutStore()
const userStore = useUserStore()
const checkInOutUser = ref<User | null>(null)
const form = ref(false)
const enterUser = ref('')
const enterPassword = ref('')
const loading = ref(false)
const visible = ref(false)
const required = (v: string) => !!v || 'Field is required'

const CheckmarkDialog = ref(false)
function performAction() {
  // แสดง v-dialog ด้วยเลื่อนเปิดเป็นระยะเวลา 2 วินาที
  CheckmarkDialog.value = true
  setTimeout(() => {
    CheckmarkDialog.value = false
  }, 2000)
}

function onSubmit() {
  if (!form.value) return
  loading.value = true
  setTimeout(() => {
    loading.value = false
    checkInOutUser.value = userStore.checkInOutAuthor(enterUser.value, enterPassword.value)
    console.log('checkInOutUser: ', checkInOutUser.value)
    console.log('Prepare Login')
    saveLogin()
  }, 2000)

  function saveLogin() {
    console.log('saveLogin')
    const editedCheckDate: CheckDate = checkInOutStore.newCheckDate
    console.log('editedCheckDate: ', editedCheckDate)
    const editedCheckUser: CheckUser = checkInOutStore.newCheckUser
    console.log('editedCheckUser: ', editedCheckUser)
    const startDate = editedCheckDate.date
    console.log('startDate: ', startDate)
    console.log('startDate: ', startDate.getTime())

    let resultIndex = binarySearch(checkInOutStore.checkDates, startDate)
    console.log('resultIndex: ', resultIndex)

    if (resultIndex !== -1 && checkInOutUser.value != null) {
      //check Out
      console.log('condition 1:')
      console.log(startDate + ' is equal to ' + checkInOutStore.checkDates[resultIndex])
      let indexCheckUser = ref(0)
      for (const checkUser of checkInOutStore.checkDates[resultIndex].checkUser) {
        if (checkUser.id === checkInOutUser.value.id) {
          // พบ checkUser ที่ตรงกัน
          checkInOutStore.assignTimeOutCheckUser(checkUser, new Date())
          checkInOutStore.checkDates[resultIndex].checkUser[indexCheckUser.value] = checkUser
          console.log('editedCheckUser: ', checkUser)
          break // เมื่อเจอแล้วไม่ต้องทำการวนลูปต่อ
        }
        indexCheckUser.value++
      }
      indexCheckUser.value = 0
      checkInOutUser.value = null
      performAction()
      enterUser.value = ''
      enterPassword.value = ''
    } else {
      //check In
      console.log('condition 2(else):')
      console.log('No matching date found and if haveing user Save new one.')
      console.log('checkInOutUser: ', checkInOutUser.value)
      if (checkInOutUser.value != null) {
        console.log('true')

        console.log(
          'checkInOutStore.formatDate(startDate): ',
          checkInOutStore.formatDate(startDate)
        )
        const onlyDate: string = checkInOutStore.formatDate(startDate)
        editedCheckDate.date = onlyDate as unknown as Date
        console.log('editedCheckDate.date: ', editedCheckDate.date)
        console.log('after test')

        checkInOutStore.assignCheckUser(
          editedCheckUser,
          checkInOutUser.value.id,
          checkInOutUser.value.fullName,
          startDate
        )
        editedCheckDate.checkUser.push(editedCheckUser)
        console.log('editedCheckUser: ', editedCheckDate.checkUser)
        checkInOutStore.checkDates.push(editedCheckDate)
        console.log('editedCheckUser: ', checkInOutStore.checkDates)
        console.log('Login success')
        checkInOutUser.value = null
        performAction()
        enterUser.value = ''
        enterPassword.value = ''
      }
    }
  }

  function binarySearch(array: any, targetDate: Date) {
    console.log('binary')
    let left = 0
    let right = array.length - 1
    console.log('right: ', right)

    while (left <= right) {
      let mid = Math.floor((left + right) / 2)
      console.log('mid: ', mid)
      let midDate = array[mid].date
      console.log('midDate: ', midDate)
      let midDateFormatted = checkInOutStore.formatDate(midDate)
      console.log('midDateFormatted: ', midDateFormatted)
      let targetDateFormatted = checkInOutStore.formatDate(targetDate)
      console.log('targetDateFormatted: ', targetDateFormatted)

      if (midDateFormatted === targetDateFormatted) {
        return mid // พบวันที่ตรงกัน
      } else if (midDateFormatted < targetDateFormatted) {
        left = mid + 1 // ค้นหาในข้างขวา
      } else {
        right = mid - 1 // ค้นหาในข้างซ้าย
      }
    }

    return -1 // ไม่พบวันที่ตรงกัน
  }
}
</script>

<template>
  <v-sheet>
    <v-card class="mx-auto pa-12 pb-8 my-auto" elevation="8" max-width="448" rounded="lg">
      <v-form v-model="form" @submit.prevent="onSubmit">
        <div class="text-subtitle-1 text-medium-emphasis">Account</div>

        <v-text-field
          v-model="enterUser"
          :readonly="loading"
          :rules="[required]"
          class="mb-2"
          clearable
          label="User Name"
          prepend-inner-icon="mdi-account-outline"
        ></v-text-field>

        <div class="text-subtitle-1 text-medium-emphasis d-flex align-center justify-space-between">
          Password
        </div>

        <v-text-field
          v-model="enterPassword"
          :append-inner-icon="visible ? 'mdi-eye-off' : 'mdi-eye'"
          :type="visible ? 'text' : 'password'"
          :readonly="loading"
          :rules="[required]"
          clearable
          label="Password"
          placeholder="Enter your password"
          prepend-inner-icon="mdi-lock-outline"
          @click:append-inner="visible = !visible"
        ></v-text-field>

        <v-card class="mb-12" color="surface-variant" variant="tonal">
          <v-card-text class="text-medium-emphasis text-caption">
            Status : UserName= Krit Password = pass1234
          </v-card-text>
        </v-card>

        <v-btn
          :disabled="!form"
          :loading="loading"
          block
          class="mb-8"
          type="submit"
          color="blue"
          size="large"
          variant="tonal"
        >
          Access
        </v-btn>
      </v-form>
    </v-card>
  </v-sheet>

  <CheckmarkDialogVue v-model="CheckmarkDialog"></CheckmarkDialogVue>
</template>
